//arrow trail
datablock ParticleData(namewandTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 200;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/star1";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 1 0.2";
	colors[1]	= "1 1 1 0.0";
	sizes[0]	= 0.2;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(namewandTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = namewandTrailParticle;
};

//effects
datablock ParticleData(namewandExplosionParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.8 0 0.8 0.9";
	colors[1]     = "1 0 1 0.0";
	sizes[0]      = 0.6;
	sizes[1]      = 0.0;
};

datablock particleData(namewandParticleA)
{
	colors[0]          = "0.2 0 0.1 0.9";
	colors[1]          = "0.1 0 0.1 0.9";
	colors[2]          = "0.7 0 0.7 0.9";
	colors[3]          = "0.8 0 0.8 0.9";
	gravityCoefficient = -0.5;
	lifetimeMS         = 600;
	lifetimeVarianceMS = 200;
	sizes[0]           = 0.1;
	sizes[1]           = 0.2;
	sizes[2]           = 0.4;
	spinRandomMax      = 90;
	spinRandomMin      = -90;
	textureName        = "base/data/particles/star1";
	times[1]           = 0.8;
	times[2]           = 1;
};

datablock particleEmitterData(namewandEmitterA)
{
	ejectionOffset   = 0.09;
	ejectionPeriodMS = 10;
	ejectionVelocity = 0.2;
	particles        = "namewandParticleA";
	periodVarianceMS = 2;
	thetaMax         = 180;
	velocityVariance = 0;
};

datablock particleData(namewandParticleB)
{
	colors[0]          = "0.2 0 0.1 0.9";
	colors[1]          = "0.1 0 0.1 0.9";
	colors[2]          = "0.7 0 0.7 0.9";
	colors[3]          = "0.8 0 0.8 0.9";
	gravityCoefficient = -0.2;
	inheritedVelFactor = 0.5;
	lifetimeMS         = 600;
	lifetimeVarianceMS = 200;
	sizes[0]           = 0.1;
	sizes[1]           = 0.2;
	sizes[2]           = 0.4;
	spinRandomMax      = 90;
	spinRandomMin      = -90;
	textureName        = "base/data/particles/star1";
	times[1]           = 0.8;
	times[2]           = 1;
};

datablock particleEmitterData(namewandEmitterB)
{
	ejectionOffset   = 0.1;
	ejectionPeriodMS = 4;
	ejectionVelocity = 0.2;
	particles        = "namewandParticleB";
	periodVarianceMS = 2;
	thetaMax         = 180;
	velocityVariance = 0;
};

datablock ParticleEmitterData(namewandExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "namewandExplosionParticle";
};

datablock ExplosionData(namewandExplosion)
{
   //explosionShape = "";

   lifeTimeMS = 150;

   particleEmitter = namewandExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "3 3 3";
   soundProfile   = "wandHitSound";
   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2.5;
   lightEndRadius = 0.5;
   lightStartColor = "0.7 0.7 0";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(namewandProjectile)
{
   //projectileShapeName = "./shapes/arrow.dts";

   directDamage        = 0;
   directDamageType    = $DamageType::ArrowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::ArrowDirect;

   explosion           = namewandExplosion;
   //particleEmitter     = namewandTrailEmitter;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 150;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(namewandItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/wand.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Name Wand";
	iconName = "base/client/ui/itemIcons/Wand";
	doColorShift = true;
	colorShiftColor = "1.5 0 1.5 1.000";

	 // Dynamic properties defined by the scripts
	image = namewandImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(namewandImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/wand.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1.2 -0.25";
   rotation = eulerToMatrix( "0 0 10" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = namewandItem;
   ammo = " ";
   projectile = namewandProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = namewandItem.colorShiftColor;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateAllowImageChange[2]        = "0";
	stateEmitter[1]                 = "namewandEmitterA";
	stateEmitter[3]                 = "namewandEmitterB";
	stateEmitterNode[1]             = "muzzlePoint";
	stateEmitterNode[3]             = "blah";
	stateEmitterTime[1]             = "0.15";
	stateEmitterTime[3]             = "0.4";
	stateFire[3]                    = "1";
	stateName[0]                    = "Activate";
	stateName[1]                    = "Ready";
	stateName[2]                    = "PreFire";
	stateName[3]                    = "Fire";
	stateName[4]                    = "CheckFire";
	stateName[5]                    = "StopFire";
	stateScript[2]                  = "onPreFire";
	stateScript[3]                  = "onFire";
	stateScript[5]                  = "onStopFire";
	stateSequence[3]                = "fire";
	stateSequence[5]                = "StopFire";
	stateTimeoutValue[2]            = "0.1";
	stateTimeoutValue[3]            = "0.2";
	stateTimeoutValue[5]            = "0.2";
	stateTransitionOnTimeout[0]     = "ready";
	stateTransitionOnTimeout[1]     = "ready";
	stateTransitionOnTimeout[2]     = "fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTransitionOnTimeout[5]     = "ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateTransitionOnTriggerDown[4] = "fire";
	stateTransitionOnTriggerUp[4]   = "StopFire";


};

function namewandImage::onPreFire(%this, %obj, %slot)
	{
		%obj.playThread(2, "armAttack");
	}

function namewandImage::onStopFire(%this, %obj, %slot)
	{
		%obj.playThread(2, "root");
	}